1 diff --git a/app/flatpak-builtins-build-export.c b/app/flatpak-builtins-build-export.c
2 index 3f5d8a1f..79493e61 100644
3 --- a/app/flatpak-builtins-build-export.c
4 +++ b/app/flatpak-builtins-build-export.c
5 @@ -464,7 +464,7 @@ validate_desktop_file (GFile *desktop_file,
6 subprocess = g_subprocess_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE |
7 G_SUBPROCESS_FLAGS_STDERR_PIPE |
8 G_SUBPROCESS_FLAGS_STDERR_MERGE,
9 - &local_error, "desktop-file-validate", path, NULL);
10 + &local_error, "@dfu@/bin/desktop-file-validate", path, NULL);
13 if (!g_error_matches (local_error, G_SPAWN_ERROR, G_SPAWN_ERROR_NOENT))
14 diff --git a/tests/libtest.sh b/tests/libtest.sh
15 index 36d39ac4..3ad2c7a6 100644
16 --- a/tests/libtest.sh
17 +++ b/tests/libtest.sh
18 @@ -511,7 +511,7 @@ if [ -z "${FLATPAK_BWRAP:-}" ]; then
19 # running installed-tests: assume we know what we're doing
20 _flatpak_bwrap_works=true
21 elif ! "$FLATPAK_BWRAP" --unshare-ipc --unshare-net --unshare-pid \
22 - --ro-bind / / /bin/true > bwrap-result 2>&1; then
23 + --ro-bind / / @coreutils@/bin/true > bwrap-result 2>&1; then
24 _flatpak_bwrap_works=false
26 _flatpak_bwrap_works=true
27 @@ -591,7 +591,7 @@ dbus-daemon --fork --config-file=session.conf --print-address=3 --print-pid=4 \
28 export DBUS_SESSION_BUS_ADDRESS="$(cat dbus-session-bus-address)"
29 DBUS_SESSION_BUS_PID="$(cat dbus-session-bus-pid)"
31 -if ! /bin/kill -0 "$DBUS_SESSION_BUS_PID"; then
32 +if ! @coreutils@/bin/kill -0 "$DBUS_SESSION_BUS_PID"; then
33 assert_not_reached "Failed to start dbus-daemon"
36 @@ -606,7 +606,7 @@ commit_to_path () {
40 - /bin/kill -9 $DBUS_SESSION_BUS_PID
41 + @coreutils@/bin/kill -9 $DBUS_SESSION_BUS_PID
42 gpg-connect-agent --homedir "${FL_GPG_HOMEDIR}" killagent /bye >&2 || true
43 fusermount -u $XDG_RUNTIME_DIR/doc >&2 || :
44 kill $(jobs -p) &> /dev/null || true
45 diff --git a/tests/make-test-app.sh b/tests/make-test-app.sh
46 index afa11a6b..5b12055f 100755
47 --- a/tests/make-test-app.sh
48 +++ b/tests/make-test-app.sh
49 @@ -190,13 +190,13 @@ msgid "Hello world"
52 mkdir -p ${DIR}/files/de/share/de/LC_MESSAGES
53 -msgfmt --output-file ${DIR}/files/de/share/de/LC_MESSAGES/helloworld.mo de.po
54 +@gettext@/bin/msgfmt --output-file ${DIR}/files/de/share/de/LC_MESSAGES/helloworld.mo de.po
57 msgstr "Bonjour le monde"
59 mkdir -p ${DIR}/files/fr/share/fr/LC_MESSAGES
60 -msgfmt --output-file ${DIR}/files/fr/share/fr/LC_MESSAGES/helloworld.mo fr.po
61 +@gettext@/bin/msgfmt --output-file ${DIR}/files/fr/share/fr/LC_MESSAGES/helloworld.mo fr.po
63 flatpak build-finish ${DIR} >&2
65 diff --git a/tests/make-test-runtime.sh b/tests/make-test-runtime.sh
66 index 4ba950df..fd50fab3 100755
67 --- a/tests/make-test-runtime.sh
68 +++ b/tests/make-test-runtime.sh
69 @@ -28,9 +28,10 @@ EOF
71 # On Debian derivatives, /usr/sbin and /sbin aren't in ordinary users'
72 # PATHs, but ldconfig is kept in /sbin
73 -PATH="$PATH:/usr/sbin:/sbin"
74 +PATH="$PATH:@socat@/bin:/usr/sbin:/sbin"
76 # Add bash and dependencies
77 +mkdir -p ${DIR}/nix/store
78 mkdir -p ${DIR}/usr/bin
79 mkdir -p ${DIR}/usr/lib
80 ln -s ../lib ${DIR}/usr/lib64
81 @@ -40,40 +41,17 @@ if test -f /sbin/ldconfig.real; then
83 cp "$(type -P ldconfig)" "${DIR}/usr/bin"
92 - if grep -qFe "${f}" $BINS; then
99 - # Add library dependencies
100 - (ldd "${f}" | sed "s/.* => //" | awk '{ print $1}' | grep ^/ | sort -u -o $LIBS $LIBS -) || true
102 - local shebang=$(sed -n '1s/^#!\([^ ]*\).*/\1/p' "${f}")
103 - if [ x$shebang != x ]; then
108 for i in $@ bash ls cat echo readlink socat; do
112 -for i in `cat $BINS`; do
113 - #echo Adding binary $i 1>&2
114 - cp "$i" ${DIR}/usr/bin/
116 -for i in `cat $LIBS`; do
117 - #echo Adding library $i 1>&2
118 - cp "$i" ${DIR}/usr/lib/
119 + I=$(readlink -f "$(type -P "$i")")
120 + [ -e "${DIR}/usr/bin/$i" ] && continue
121 + requisites=$(nix-store --query --requisites "$I")
122 + for r in $requisites; do
123 + # a single store item can be needed by multiple paths, no need to copy it again
124 + if [ ! -e "${DIR}/$r" ]; then
125 + cp -r "$r" "${DIR}/$r"
128 + ln -s "$I" "${DIR}/usr/bin/$i"
130 ln -s bash ${DIR}/usr/bin/sh
132 @@ -84,11 +62,13 @@ echo "Hello world, from a runtime$EXTRA"
134 chmod a+x ${DIR}/usr/bin/runtime_hello.sh
136 -# We copy the C.UTF8 locale and call it en_US. Its a bit of a lie, but
137 -# the real en_US locale is often not available, because its in the
139 -mkdir -p ${DIR}/usr/lib/locale/
140 -cp -r /usr/lib/locale/C.* ${DIR}/usr/lib/locale/en_US
141 +# We do not copy C.UTF8 locale because it is in locale archive and
142 +# that is already copied with glibc.
144 +mv "${DIR}/nix/store" "${DIR}/usr/store" # files outside /usr are not permitted, we will have to replace /nix/store with /usr/store
145 +chmod -R u+w "${DIR}" # nix store has read-only directories which would cause problems during clean-up, files need to be writable for sed
146 +find "${DIR}" -type f -print0 | xargs -0 sed -i 's~/nix/store/~/usr/store/~g' # replace hardcoded paths
147 +find "${DIR}" -type l | xargs -I '{}' sh -c 'tg="$(readlink "$1")"; newtg="${tg#/nix/store/}"; if [ "$tg" != "$newtg" ]; then ln -fs "/usr/store/$newtg" "$1"; fi' -- '{}' # replace symlink targets
149 if [ x$COLLECTION_ID != x ]; then
150 collection_args=--collection-id=${COLLECTION_ID}
151 diff --git a/tests/testlibrary.c b/tests/testlibrary.c
152 index 831d85c1..ae4f03d0 100644
153 --- a/tests/testlibrary.c
154 +++ b/tests/testlibrary.c
155 @@ -1601,7 +1601,7 @@ check_bwrap_support (void)
158 char *argv[] = { (char *) bwrap, "--unshare-ipc", "--unshare-net",
159 - "--unshare-pid", "--ro-bind", "/", "/", "/bin/true", NULL };
160 + "--unshare-pid", "--ro-bind", "/", "/", "@coreutils@/bin/true", NULL };
161 g_autofree char *argv_str = g_strjoinv (" ", argv);
162 g_test_message ("Spawning %s", argv_str);
163 g_spawn_sync (NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, &exit_code, &error);
164 diff --git a/triggers/desktop-database.trigger b/triggers/desktop-database.trigger
165 index 1037466d..c4c7ed6d 100755
166 --- a/triggers/desktop-database.trigger
167 +++ b/triggers/desktop-database.trigger
171 -if command -v update-desktop-database >/dev/null && test -d "$1/exports/share/applications"; then
172 - exec update-desktop-database -q "$1/exports/share/applications"
173 +if test -d "$1/exports/share/applications"; then
174 + exec @dfu@/bin/update-desktop-database -q "$1/exports/share/applications"
176 diff --git a/triggers/gtk-icon-cache.trigger b/triggers/gtk-icon-cache.trigger
177 index d9fc8251..d8ddb96e 100755
178 --- a/triggers/gtk-icon-cache.trigger
179 +++ b/triggers/gtk-icon-cache.trigger
183 -if command -v gtk-update-icon-cache >/dev/null && test -d "$1/exports/share/icons/hicolor"; then
184 - cp /usr/share/icons/hicolor/index.theme "$1/exports/share/icons/hicolor/"
185 +if test -d "$1/exports/share/icons/hicolor"; then
186 + @coreutils@/bin/cp -f @hicolorIconTheme@/share/icons/hicolor/index.theme "$1/exports/share/icons/hicolor/"
187 for dir in "$1"/exports/share/icons/*; do
188 if test -f "$dir/index.theme"; then
189 - if ! gtk-update-icon-cache --quiet "$dir"; then
190 - echo "Failed to run gtk-update-icon-cache for $dir"
191 + if ! @gtk3@/bin/gtk-update-icon-cache --quiet "$dir"; then
192 + @coreutils@/bin/echo "Failed to run gtk-update-icon-cache for $dir"
195 diff --git a/triggers/mime-database.trigger b/triggers/mime-database.trigger
196 index 10ddbbb3..c270998a 100755
197 --- a/triggers/mime-database.trigger
198 +++ b/triggers/mime-database.trigger
202 -if command -v update-mime-database >/dev/null && test -d "$1/exports/share/mime/packages"; then
203 - exec update-mime-database "$1/exports/share/mime"
204 +if test -d "$1/exports/share/mime/packages"; then
205 + exec @smi@/bin/update-mime-database "$1/exports/share/mime"